/* $Id: dsp.c,v 1.2 1996/03/26 22:46:25 james Exp james $ */
/*
 * $Log: dsp.c,v $
 * Revision 1.2  1996/03/26 22:46:25  james
 * Put the function return types on the line before the function's name.
 *
 * Revision 1.1  1995/03/30 20:24:12  james
 * Initial revision
 *
 */

#include <unistd.h>		/* usleep() */
#include "jy_sg.h"

static IOADDR Bbase = 0x220;		/* SoundBlaster base address */

/*
 *  DSP functions
 */
void 
set_sb_bbase(IOADDR base)
{
  Bbase = base;
}

IOADDR
get_sb_bbase(void)
{
  return Bbase;
}

void
write_dsp(BYTE val)
{
  BYTE status;

  /* Wait for the write buffer to become available. */
  do
    {
      status = read_io_byte(DSP_WRITE_STATUS_PORT);
    } while( status & DSP_WRITE_BUSY_BIT);
  
  write_io_byte(DSP_COMMAND_PORT, val);
}

BYTE
read_dsp(void)
{
  BYTE status;
  
  /* Wait for data to become available. */
  do
    {
      status = read_io_byte(DSP_DATA_AVAILABLE_PORT);
    } while( (status & DSP_DATA_AVAILABLE_BIT) == 0);
  return read_io_byte(DSP_DATA_PORT);
}

int
detect_dsp(void)
{
  const int ten_microsec = 10uL;
  const int thirty_microsec = 30uL;
  register int loopc;
  
  write_io_byte(DSP_RESET_PORT, 1);
  usleep(ten_microsec);
  write_io_byte(DSP_RESET_PORT, 0);
  usleep(thirty_microsec);
  
  for (loopc=0; loopc<1000; loopc++)
    if (read_io_byte(DSP_DATA_AVAILABLE_PORT) & DSP_DATA_AVAILABLE_BIT)
      break;

   if (read_io_byte(DSP_DATA_PORT) == 0xAA)
     return 1;			/* success. */
   else
     return 0;			/* failure */
}
